width = 90;
height = 90;
depth = 35;
thickness = 2.5;
bolt_d = 2.5;

top_hole_d = 8;
top_thick = 10;

// SO239 info according to https://static.chipdip.ru/lib/249/DOC000249075.pdf
front_d = 16;
front_off = 18.8;
front_hole_d = 3.2;
side_d = 3.2;
side_bolt_head_d = 5;

module top() {
translate([0,0,depth/2]) difference() {
translate([-width/2,-height/2,0])
    difference() {
        cube([width,height,thickness]);
        translate([0,width/2+5,thickness-1]) linear_extrude(height=2)
        union() {
            translate([12,0,0])
                text("R2AUK", size=15);
            translate([2, -20, 0])
                text("1:1 balun", size=15);
        }
    }

translate([-width/2+1.5*bolt_d,-height/2+1.5*bolt_d,0])
    cylinder(d=bolt_d,h=20,$fn=100,center=true);
    
translate([-width/2+1.5*bolt_d,height/2-1.5*bolt_d,0])
    cylinder(d=bolt_d,h=20,$fn=100,center=true);
    
translate([width/2-1.5*bolt_d,height/2-1.5*bolt_d,0])
    cylinder(d=bolt_d,h=20,$fn=100,center=true);
    
translate([width/2-1.5*bolt_d,-height/2+1.5*bolt_d,0])
    cylinder(d=bolt_d,h=20,$fn=100,center=true);
}
} // top


module bottom() {
union() {
    difference() {
        union() {
        translate([0, height/2-top_thick/2, 0])
                cube([width, top_thick, depth], center=true);
        difference() {
            cube([width,height,depth], center=true);
            translate([0,0,thickness])
                cube([width-2*thickness,height-2*thickness, depth], center=true);
        }
        
        /*
        translate([-width/2+bolt_d*1.5, -height/2+bolt_d*1.5, 0])
            cylinder(d=bolt_d*3,h=depth, $fn=100, center=true);
        
        translate([width/2-bolt_d*1.5, -height/2+bolt_d*1.5, 0])
            cylinder(d=bolt_d*3,h=depth, $fn=100, center=true);
        */
        
        translate([-width/2, width/2, 0]) rotate([0,0,30])
            cube([width/2, width/2, depth], center=true);
        
        translate([width/2, width/2, 0]) rotate([0,0,-30])
            cube([width/2, width/2, depth], center=true);
        
        translate([-width*11/20, -width*11/20, 0]) rotate([0,0,45])
            cube([width/2, width/2, depth], center=true);
        
        translate([width*11/20, -width*11/20, 0]) rotate([0,0,45])
            cube([width/2, width/2, depth], center=true);
        } // union
        
        translate([0, width/5, 0]) rotate([0, 90, 0])
            cylinder(d=side_bolt_head_d, h=width-thickness*2, $fn=100m, center=true);
               
        translate([-width/2-depth, 0, 0]) rotate([0,0,90])
            cube([width*2,depth*2, height*2], center=true);
        
        translate([width/2+depth, 0, 0]) rotate([0,0,90])
            cube([width*2,depth*2, height*2], center=true);
        
        translate([0, width/2+depth/2, 0])
            cube([width*2,depth, height*2], center=true);
        
        translate([0, -width/2-depth/2, 0])
            cube([width*2,depth, height*2], center=true);
        
        rotate([90,0,0])
            cylinder(d=top_hole_d, h = width*2, $fn=100, center=true);
        
        translate([width/3,width/2-5,0]) rotate([90,0,90-30])
            cylinder(d=top_hole_d, h=width, $fn=100, center=true);

        translate([-width/3,width/2-5,0]) rotate([90,0,-90+30])
            cylinder(d=top_hole_d, h=width, $fn=100, center=true);
        
        translate([-width/2+bolt_d*1.5, -height/2+bolt_d*1.5, thickness])
            cylinder(d=bolt_d,h=depth, $fn=100, center=true);
        
        translate([width/2-bolt_d*1.5, -height/2+bolt_d*1.5, thickness])
            cylinder(d=bolt_d,h=depth, $fn=100, center=true);
        
        translate([-width/2+bolt_d*1.5, height/2-bolt_d*1.5, thickness])
            cylinder(d=bolt_d,h=depth, $fn=100, center=true);
            
        translate([width/2-bolt_d*1.5, height/2-bolt_d*1.5, thickness])
            cylinder(d=bolt_d,h=depth, $fn=100, center=true);
        
        translate([0, -width/2, 0]) rotate([90,0,0])
            cylinder(d=front_d,h=20, $fn=100, center=true);
        
        translate([-front_off/2, -width/2, -front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
        
        translate([front_off/2, -width/2, -front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
        
        translate([front_off/2, -width/2, front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
        
        translate([-front_off/2, -width/2, front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
        
        translate([0, width/5, 0]) rotate([0,90,0])
            cylinder(d=side_d,h=width*2, $fn=100, center=true);
    }
} // union
} // bottom

// top();
bottom();